package my.petstore.entity;

import java.util.Date;
import java.util.HashSet;
import java.util.Set;

public class OrderData extends BaseEntity {

    private OrderData() {}
    public OrderData(Cart cart) {
        orderDate = new Date();

        creditCard = "999 9999 9999 9999";
        expiryDate = "12/03";
        cardType = "Visa";
        setStatus(new OrderStatus(new Date(), "P", this));
        
        if (cart != null) {
            totalPrice = cart.getTotal();
            for (CartItem cartItem : cart.getAllCartItems()) {
                addLineItem(cartItem);
            }
        }
    }

    private Date orderDate;
    private int totalPrice;
    private String shipAddress;
    private String shipToName;
    private String creditCard;
    private String expiryDate;
    private String cardType;

    private OrderStatus status;
    private Set<LineItem> lineItems = new HashSet<LineItem>();

    public Date getOrderDate() { return orderDate; }
    public void setOrderDate(Date orderDate) { this.orderDate = orderDate; }

    public int getTotalPrice() { return totalPrice; }
    public void setTotalPrice(int totalPrice) { this.totalPrice = totalPrice; }

    public String getShipAddress() { return shipAddress; }
    public void setShipAddress(String shipAddress) { this.shipAddress = shipAddress; }

    public String getShipToName() { return shipToName; }
    public void setShipToName(String shipToName) { this.shipToName = shipToName; }

    public String getCreditCard() { return creditCard; }
    public void setCreditCard(String creditCard) { this.creditCard = creditCard; }

    public String getExpiryDate() { return expiryDate; }
    public void setExpiryDate(String expiryDate) { this.expiryDate = expiryDate; }

    public String getCardType() { return cardType; }
    public void setCardType(String cardType) { this.cardType = cardType; }

    public OrderStatus getStatus() { return status; }
    public void setStatus(OrderStatus status) { this.status = status; }


    public Set<LineItem> getLineItems() { return lineItems; }
    public void setLineItems(Set<LineItem> status) { this.lineItems = lineItems; }

    private void addLineItem(CartItem cartItem) {
        LineItem lineItem = new LineItem(this, lineItems.size() + 1, cartItem);
        addLineItem(lineItem);
    }

    private void addLineItem(LineItem lineItem) {
        lineItems.add(lineItem);
    }

    public static final OrderData NULL = new OrderData() {
        {
            setOrderDate(new Date());
            setShipAddress("");
            setShipToName("");
            setCreditCard("");
            setExpiryDate("");
            setCardType("");
            setStatus(new OrderStatus(null, null, this));
        }
    };
}
