package my.petstore.web;

import my.petstore.entity.Item;
import my.petstore.service.ProductService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

@Controller
public class ItemController {

    @Autowired
    private ProductService productService;

    @RequestMapping(value="/items/{itemId}", method=RequestMethod.GET)
    public String handleRequest(@PathVariable Integer itemId, Model model) {
        Item item = productService.getItem(itemId);
        model.addAttribute("item", item);
        model.addAttribute("product", item.getProduct());
        return "Item";
    }
}
